moSetGetVehicles = {};

function moSetGetVehicles:setVehicles(self)
	--if moGeneralSettings.vehicleControlled[3] == nil then moGeneralSettings.vehicleControlled[3] = 0;end;
	--moGeneralSettings.vehicleControlled[3] = moGeneralSettings.vehicleControlled[3]+1;
	--if moGeneralSettings.vehicleControlled[3] < 100 then return;end;
	--moGeneralSettings.vehicleControlled[3] = 0;
	moVehicles = {};
	--for a=1, 6 do --1 tractor,drescher,frontloader,telehandler,wheelloader,rest
		--moVehicles.sort[a] = {};
	--end;
	moGeneralSettings.vehicleControlled[1] = 0;
	if moGeneralSettings.vehicleControlled[2] == nil then
		moGeneralSettings.vehicleControlled[2] = {};
	end;
	local vehiclesLength = table.getn(g_currentMission.steerables);
	--local vehiclesLength = table.getn(g_currentMission.vehicles); 
	if vehiclesLength > 0 then 
		for a=1, vehiclesLength do 
			local vehicle = g_currentMission.steerables[a];	
			moVehicles[a] = {};
			moVehicles[a].object = vehicle;
			moVehicles[a].isControlled = Utils.getNoNil(vehicle.isControlled, false);
			moVehicles[a].hired = Utils.getNoNil(vehicle.isHired, false);			
			local parked = Utils.getNoNil(vehicle.vs_isParked, false);
			if moSetGetGui.pdaVI.seeParked then parked = false;end; 
			if moVehicles[a].isControlled or moVehicles[a].hired or (moSetGetGui.pdaVI.compactDisplay > 0 and not parked) then
				moGeneralSettings.vehicleControlled[1] = moGeneralSettings.vehicleControlled[1]+1
				if moGeneralSettings.vehicleControlled[2][vehicle.rootNode] == nil then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode] = {};
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = 0;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer = 0; --3 stufen a 100
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningWater = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningFuelTank = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCar = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer = 0;					
					--moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningOel = false;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRepair = false;
				end;
				moVehicles[a].MPOwner = "";
				if vehicle.MPOwner ~= nil then
					moVehicles[a].MPOwner = Utils.getNoNil(vehicle.MPOwner.owner, "");
				end;
				moVehicles[a].area = {};
				moVehicles[a].rootNode = vehicle.rootNode;
				moVehicles[a].isSteerable = Utils.getNoNil(vehicle.isSteerable, false);
				moVehicles[a].name = Utils.getNoNil(vehicle.name, setVehicleName(self, g_currentMission.steerables[a], vehicle, false));				
				moVehicles[a].isMotorStarted = Utils.getNoNil(vehicle.isMotorStarted, false);			
				moVehicles[a].controllerName = Utils.getNoNil(vehicle.controllerName, "");
				moVehicles[a].controllerNameHired = Utils.getNoNil(vehicle.controllerName, "");
				moVehicles[a].waitingForTrailerToUnload = Utils.getNoNil(vehicle.waitingForTrailerToUnload, false);
				moVehicles[a].vehicleType = Utils.getNoNil(vehicle.typeName, "");
				moVehicles[a].typeDesc = Utils.getNoNil(vehicle.typeDesc, "");
				--moVehicles[a].oel = Utils.getNoNil(vehicle.oelChange, -1);
				moVehicles[a].repair = Utils.getNoNil(vehicle.damageLevel, -1);
				if string.find(string.lower(moVehicles[a].typeDesc), "missing") or string.find(string.lower(moVehicles[a].typeDesc), "typedescription") then
					moVehicles[a].typeDesc = "unknown"
				end;
				if string.find(string.lower(moVehicles[a].controllerName), "unknown") or not moVehicles[a].isControlled then moVehicles[a].controllerName = "";end;
				if moVehicles[a].vehicleType == "attachableFrontloader" then moVehicles[a].vehicleType = "frontLoader";end;
				moVehicles[a].overlay = "unknown";			
				moVehicles[a].seedsSprayer = false;			
				moVehicles[a].fruitName = "!";
				moVehicles[a].parking = false;
				moVehicles[a].owner = "";
				moVehicles[a].field = 0;
				moVehicles[a].warningCapacityColor = moSetGetGui.pdaVI.defaultColor;
				local foundCollision = false;
				local speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3600; --lastSpeed,speedDisplayDt
				if not moVehicles[a].isControlled and not moVehicles[a].hired then speed = 0;end;
				if moVehicles[a].name == "Train" then speed = Utils.getNoNil(vehicle.speed, 0)*3.6;end;
				moVehicles[a].speed = string.format("%1.0f", "".. Utils.getNoNil(speed, 0));
				if tonumber(speed) <= 1.0 and tonumber(speed) >= 0.001 then --or tonumber(speed) <= moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = tonumber(speed);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer+1
					if moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer > 1000 then
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = true;
						foundCollision = true;
					end;
				elseif tonumber(speed) <= 0 or moVehicles[a].waitingForTrailerToUnload then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = tonumber(speed);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer+1
					if moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer > 1000 then
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = true;
					end;
				else
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].lastSpeed = tonumber(speed);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
				end;
				if Utils.getNoNil(vehicle.showWaterWarning, false) then
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningWater = true;
				else
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningWater = false;
				end;
				local blinkTimer = 300;
				if vehicle.damageLevel ~= nil then blinkTimer = 450;end;
				moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer+1;
				if moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer > blinkTimer then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].blinkTimer = 0;end;
				moVehicles[a].hiredA = false;
				moVehicles[a].hiredC = false;
				moVehicles[a].damageValues = 0;
				moVehicles[a].damage = false;
				moVehicles[a].attached = 0;	
				local fillLevelInformations = {};				
				getFillLevelInformation(vehicle, fillLevelInformations, false, 0);
				if #fillLevelInformations > 0 then
					for v=1, #fillLevelInformations do
						if fillLevelInformations[v] ~= nil and not fillLevelInformations[v].isAttached then
							if fillLevelInformations[v].fillType ~= nil then
								local desc = FillUtil.fillTypeIndexToDesc[fillLevelInformations[v].fillType];
								if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
									moVehicles[a].fruitName = moFillTypes[desc.index].fruitName;
								end;
							end;							
							if fillLevelInformations[v].isSeeds then								
								local seeds = "";
								moVehicles[a].seedsSprayer = true;
								if moFillTypes[fillLevelInformations[v].seedsFruitType] ~= nil and moFillTypes[fillLevelInformations[v].seedsFruitType].fruitName ~= nil then
									moVehicles[a].fruitName = moFillTypes[fillLevelInformations[v].seedsFruitType].fruitName;
								end;								
								local desc = FillUtil.fillTypeIndexToDesc[fillLevelInformations[v].seedsFruitConvertFillType];
								if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
									seeds = "(".. moFillTypes[desc.index].fruitName.. ")";
								end;
								if string.find(string.lower(seeds), "!") then seeds = "";end;
								local fruitName = moVehicles[a].fruitName;
								if string.find(fruitName, seeds) then seeds = "";end;
								moVehicles[a].fruitName = fruitName.. seeds;
							end;
							if fillLevelInformations[v].isSprayer then								
								local sprayer = "";
								moVehicles[a].seedsSprayer = true;
								if moFillTypes[fillLevelInformations[v].sprayerFruitType] ~= nil and moFillTypes[fillLevelInformations[v].sprayerFruitType].fruitName ~= nil then
									moVehicles[a].fruitName = moFillTypes[fillLevelInformations[v].sprayerFruitType].fruitName;
								end;								
								local desc = FillUtil.fillTypeIndexToDesc[fillLevelInformations[v].sprayerFruitConvertFillType];
								if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
									sprayer = "(".. moFillTypes[desc.index].fruitName.. ")";
								end;
								if string.find(string.lower(sprayer), "!") then sprayer = "";end;
								local fruitName = moVehicles[a].fruitName;
								if string.find(fruitName, sprayer) then sprayer = "";end;
								moVehicles[a].fruitName = fruitName.. sprayer;
							end;
							if fillLevelInformations[v].fillLevel ~= nil and fillLevelInformations[v].capacity ~= nil then
								moVehicles[a].fillLevel = Utils.getNoNil(fillLevelInformations[v].fillLevel, 0);
								moVehicles[a].capacity = Utils.getNoNil(fillLevelInformations[v].capacity, 0);
								moVehicles[a].fillLevelProzent = string.format("%1.0f", "".. tonumber(moVehicles[a].fillLevel)/tonumber(moVehicles[a].capacity)*100);
								moVehicles[a].warningCapacityColor = setProzentColor(moVehicles[a].fillLevelProzent, moVehicles[a].seedsSprayer, false);
							end;
							break;
						end;
					end;
				end;				
				if string.find(moVehicles[a].vehicleType, "sprayer") or string.find(moVehicles[a].vehicleType, "manureBarrel") or string.find(moVehicles[a].vehicleType, "manureSpreader") then
					moVehicles[a].seedsSprayer = true;
				end;				
				--ls17				
				if vehicle.fuelCapacity ~= nil and vehicle.fuelFillLevel ~= nil and vehicle.fuelFillLevel > 0 then
					moVehicles[a].fuelFillLevel = Utils.getNoNil(vehicle.fuelFillLevel, 0);
					moVehicles[a].fuelCapacity = Utils.getNoNil(vehicle.fuelCapacity, 0);
					moVehicles[a].fuelFillLevelProzent = string.format("%1.0f", "".. tonumber(moVehicles[a].fuelFillLevel)/tonumber(moVehicles[a].fuelCapacity)*100);
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningFuelTank = setProzentColor(moVehicles[a].fuelFillLevelProzent, false, true);
				end;
				if vehicle.damageLevel ~= nil then
					moVehicles[a].damageLevel = vehicle.damageLevel;
					moVehicles[a].warningDamageLevelColor = setProzentColor(moVehicles[a].damageLevel, false, false);
					if moVehicles[a].damageLevel >= 50 then
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRepair = true;
					else
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRepair = false;
					end;
				end;
				local warningRentCarTimerRefresh = false;
				local rentCarColorWarning = 0;
				if moSetGetGui.pdaVI.seeRentCar and vehicle.propertyState == 2 then
					moVehicles[a].name = "RC-".. tostring(moVehicles[a].name);
				end;
				if moSetGetGui.pdaVI.seeRentCar and vehicle.leasingInfos ~= nil and vehicle.leasingInfos.leased ~= nil and vehicle.leasingInfos.leased then					
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer+1;
					if moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer > 600 then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer = 0;warningRentCarTimerRefresh = true;end;
					vehicleRentCar = true;
					local day = g_currentMission.environment.currentDay;					
					if vehicle.leasingInfos.day > day then 
						day = vehicle.leasingInfos.day-g_currentMission.environment.currentDay;
						if day > 0 then day = (24*day)*3600000-(g_currentMission.environment.dayTime);end;
						dayTime = vehicle.leasingInfos.dayTime;
					else
						day = 0;
						dayTime = vehicle.leasingInfos.dayTime-g_currentMission.environment.dayTime
					end;
					local rentCarTimeColor, rentCarWarning, rentCarColor = setRentCarColor(dayTime);
					rentCarColorWarning = rentCarColor;
					moVehicles[a].warningRentCarTimeColor = rentCarTimeColor
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCar = rentCarWarning;
					if vehicle.leasingInfos.timeOver then
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCar = true;						
					end;
					if moVehicles[a].rentCarTime == nil then moVehicles[a].rentCarTime = {};end;
					table.insert(moVehicles[a].rentCarTime, #moVehicles[a].rentCarTime+1, tostring(moGuiExtras:getMilliSecondsToHours(day+(dayTime), true)));					
					if moVehicles[a].rentCarTimeWarningColor == nil then moVehicles[a].rentCarTimeWarningColor = {};end;
					table.insert(moVehicles[a].rentCarTimeWarningColor, #moVehicles[a].rentCarTimeWarningColor+1, tostring(rentCarColor));
					if moVehicles[a].rentCarOverTime == nil then moVehicles[a].rentCarOverTime = {};end;
					table.insert(moVehicles[a].rentCarOverTime, #moVehicles[a].rentCarOverTime+1, Utils.getNoNil(vehicle.leasingInfos.timeOver, false));					
					if moVehicles[a].rentCarOverTimePrice == nil then moVehicles[a].rentCarOverTimePrice = {};end;
					table.insert(moVehicles[a].rentCarOverTimePrice, #moVehicles[a].rentCarOverTimePrice+1, g_i18n:formatMoney(Utils.getNoNil(vehicle.leasingInfos.moreTimePrice, 0)));					
				end;
				if moVehicles[a].hired or (vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving()) then							 
					moVehicles[a].controllerName = "H ";									
					if vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving() then
						moVehicles[a].hiredC = true;
						moVehicles[a].controllerName = "HC ";
						if vehicle.cp ~= nil and vehicle.cp.wait then
							moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait = true;
						else
							moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait = false;
						end;
					end;
					if vehicle.numCollidingVehicles ~= nil and not moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait then
						for _,numCollisions in pairs(vehicle.numCollidingVehicles) do
							if numCollisions > 0 then
								foundCollision = true;
								moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = true
								moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
								moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
								break;
							end;
						end;						
						if not foundCollision then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = false;end;
					end;
					if vehicle.isHirableBlocked and not moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCpWait then							
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = true
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeedTimer = 0;
						moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningSpeed = false;
					end;
				else
					moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningCollision = false;
				end;
				if moVehicles[a].warningCapacityColor == nil or moVehicles[a].capacity == 0 then
					moVehicles[a].fillLevelProzent = nil;
					moVehicles[a].warningCapacityColor = moSetGetGui.pdaVI.defaultColor;
					moVehicles[a].fruitName = "";
				end;
				function getField(vehicleField)
					local fieldNumber = 0;
					if vehicleField.components ~= nil and vehicleField.components[1] ~= nil and vehicleField.components[1].node ~= nil then					
						local wx,_,wz = getWorldTranslation(vehicle.components[1].node);
						if wx~=wx or wz~=wz then
							return fieldNumber;
						end;
						
						if moFieldDef == nil or table.getn(moFieldDef) <= 0 then return fieldNumber;end;
						for fieldNum,fieldDef in ipairs(moFieldDef) do
							for _,tableValues in ipairs(fieldDef) do
								if tableValues.x1 <= wx and wx <= tableValues.x2 and tableValues.z1 <= wz and wz <= tableValues.z2 then									
									local wX, wZ, wWX, wWZ, wHX, wHZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, wx, wz, tableValues.x1, tableValues.z1, tableValues.x2, tableValues.z2);
									--ls17
									local wXX,wYY,wZZ = 0,0,0;
									if vehicleField.components ~= nil and vehicleField.components[1] ~= nil and vehicleField.components[1].node ~= nil then
										wXX,wYY,wZZ = getWorldTranslation(vehicle.components[1].node);
									end;
									local foundField = getDensityAtWorldPos(g_currentMission.terrainDetailId, wX, wYY, wZ);
									if foundField == nil or foundField <= 0 then break;end;
									fieldNumber = fieldNum;
									break;
								end;
							end;
							if fieldNumber ~= 0 then break;end;
						end;
					end;
					return fieldNumber;
				end;
				local attachedNr = 0;
				local maxAttachedNr = 5;				
				function setNextAttached(a, attachedObj)					
					for index,attached in pairs(attachedObj.attachedImplements) do
						if attached ~= nil and attached.object ~= nil then															
							setAttached(a, attached.object);
							break;							
						end;							
					end;
				end;
				function setAttached(a, attachedObj)				
					attachedNr = attachedNr+1					
					moVehicles[a].attached = moVehicles[a].attached+1
					moVehicles[a].attachedValues[attachedNr] = {};
					moVehicles[a].attachedValues[attachedNr].object = attachedObj;
					moVehicles[a].attachedValues[attachedNr].vehicleType = Utils.getNoNil(attachedObj.typeName, "unknown");
					moVehicles[a].attachedValues[attachedNr].name = Utils.getNoNil(attachedObj.name, setVehicleName(self, attachedObj, attachedObj, true));					
					moVehicles[a].attachedValues[attachedNr].typeDesc = Utils.getNoNil(attachedObj.typeDesc, "unknown");
					moVehicles[a].attachedValues[attachedNr].fillLevel = nil;
					moVehicles[a].attachedValues[attachedNr].capacity = nil;
					--ls17					
					if string.find(string.lower(moVehicles[a].attachedValues[attachedNr].typeDesc), "missing") or string.find(string.lower(moVehicles[a].attachedValues[attachedNr].typeDesc), "typedescription") then
						moVehicles[a].attachedValues[attachedNr].typeDesc = "unknown"
					end;
					if moSetGetGui.pdaVI.seeRentCar and attachedObj.propertyState == 2 then
						moVehicles[a].attachedValues[attachedNr].name = "RC-".. tostring(moVehicles[a].attachedValues[attachedNr].name);
					end;
					if moSetGetGui.pdaVI.seeRentCar and attachedObj.leasingInfos ~= nil and attachedObj.leasingInfos.leased ~= nil and attachedObj.leasingInfos.leased then					
						if moVehicles[a].rentCarTime == nil then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer = moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer+1;end;
						if not warningRentCarTimerRefresh and moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer > 600 then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCarTimer = 0;warningRentCarTimerRefresh=true;end;
						local day = g_currentMission.environment.currentDay;					
						if attachedObj.leasingInfos.day > day then 
							day = attachedObj.leasingInfos.day-g_currentMission.environment.currentDay;
							if day > 0 then day = (24*day)*3600000-(g_currentMission.environment.dayTime);end;
							dayTime = attachedObj.leasingInfos.dayTime;
						else
							day = 0;
							dayTime = attachedObj.leasingInfos.dayTime-g_currentMission.environment.dayTime
						end;
						local rentCarTimeColor, rentCarWarning, rentCarColor = setRentCarColor(dayTime);						
						if not moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCar then moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCar = rentCarWarning;moVehicles[a].warningRentCarTimeColor = rentCarTimeColor;end;
						if attachedObj.leasingInfos.timeOver then
							moGeneralSettings.vehicleControlled[2][vehicle.rootNode].warningRentCar = true;
							moVehicles[a].warningRentCarTimeColor = rentCarTimeColor;
						elseif rentCarColor > rentCarColorWarning then
							moVehicles[a].warningRentCarTimeColor = rentCarTimeColor;
							rentCarColorWarning = rentCarColor;
						end;
						if moVehicles[a].rentCarTime == nil then moVehicles[a].rentCarTime = {};end;
						table.insert(moVehicles[a].rentCarTime, #moVehicles[a].rentCarTime+1, tostring(moGuiExtras:getMilliSecondsToHours(day+(dayTime), true)));
						if moVehicles[a].rentCarTimeWarningColor == nil then moVehicles[a].rentCarTimeWarningColor = {};end;
						table.insert(moVehicles[a].rentCarTimeWarningColor, #moVehicles[a].rentCarTimeWarningColor+1, tostring(rentCarColor));
						if moVehicles[a].rentCarOverTime == nil then moVehicles[a].rentCarOverTime = {};end;
						table.insert(moVehicles[a].rentCarOverTime, #moVehicles[a].rentCarOverTime+1, Utils.getNoNil(attachedObj.leasingInfos.timeOver, false));					
						if moVehicles[a].rentCarOverTimePrice == nil then moVehicles[a].rentCarOverTimePrice = {};end;
						table.insert(moVehicles[a].rentCarOverTimePrice, #moVehicles[a].rentCarOverTimePrice+1, g_i18n:formatMoney(Utils.getNoNil(attachedObj.leasingInfos.moreTimePrice, 0)));					
					end;
					
					
					moVehicles[a].attachedValues[attachedNr].fruitName = "!";
					moVehicles[a].attachedValues[attachedNr].seedsSprayer = false;
					moVehicles[a].attachedValues[attachedNr].warningCapacityColor = moSetGetGui.pdaVI.defaultColor;	
					fillType = 0;					
					local extraFillType = false;
					if moVehicles[a].attachedValues[attachedNr].vehicleType == "attachableFrontloader" then moVehicles[a].vehicleType = "frontLoader";end;
					if moVehicles[a].attachedValues[attachedNr].vehicleType == "dynamicMountAttacherImplement" then
						if attachedObj.dynamicMountedObjects ~= nil then --dynamicMountedObjects, aiRequiredFruitType, aiProhibitedFruitType components, schemaOverlay							
							for k, v in pairs(attachedObj.dynamicMountedObjects) do 
								if k ~= nil then
									--for k1,v1 in pairs(k) do
										--print("key pallet type.... und value pallet fillLevel....".. tostring(k.fillType).. "----".. tostring(k.fillLevel))
									--end;
									extraFillType = true;
									fillType = Utils.getNoNil(k.fillType, 0); --aiRequiredFruitType, aiProhibitedFruitType, isAddedToMission
									moVehicles[a].attachedValues[attachedNr].fillLevel = Utils.getNoNil(k.fillLevel, 0);
									moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(k.capacity, 0);
									if k.fillablePalletDirtyFlag ~= nil then moVehicles[a].attachedValues[attachedNr].typeDesc = "Pallete";end;
									if k.baleMesh ~= nil then 
										moVehicles[a].attachedValues[attachedNr].typeDesc = "Bale";
										moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(k.fillLevel, 0);
									end; --physicsObjectDirtyFlag
									moVehicles[a].attachedValues[attachedNr].fillLevelProzent = string.format("%1.0f", "".. tonumber(moVehicles[a].attachedValues[attachedNr].fillLevel)/tonumber(moVehicles[a].attachedValues[attachedNr].capacity)*100);
									break;																									
								end;
							end;
						end												
					end;
					if not extraFillType or fillType == 0 then
						if #fillLevelInformations > 0 then
							local foundFill = false;
							for v=1, #fillLevelInformations do								
								if fillLevelInformations[v] ~= nil and fillLevelInformations[v].isAttached and fillLevelInformations[v].attachedNr == attachedNr then
									if fillLevelInformations[v].fillType ~= nil then
										local desc = FillUtil.fillTypeIndexToDesc[fillLevelInformations[v].fillType];
										if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
											moVehicles[a].attachedValues[attachedNr].fruitName = moFillTypes[desc.index].fruitName;
										end;
										foundFill = true;
									end;							
									if fillLevelInformations[v].isSeeds then								
										local seeds = "";
										moVehicles[a].attachedValues[attachedNr].seedsSprayer = true;
										if moFillTypes[fillLevelInformations[v].seedsFruitType] ~= nil and moFillTypes[fillLevelInformations[v].seedsFruitType].fruitName ~= nil then
											moVehicles[a].attachedValues[attachedNr].fruitName = moFillTypes[fillLevelInformations[v].seedsFruitType].fruitName;
										end;								
										local desc = FillUtil.fillTypeIndexToDesc[fillLevelInformations[v].seedsFruitConvertFillType];
										if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
											seeds = "(".. moFillTypes[desc.index].fruitName.. ")";
										end;
										if string.find(string.lower(seeds), "!") then seeds = "";end;
										local fruitName = moVehicles[a].attachedValues[attachedNr].fruitName;
										if string.find(fruitName, seeds) then seeds = "";end;
										moVehicles[a].attachedValues[attachedNr].fruitName = fruitName.. seeds;
										if fillLevelInformations[v].fillLevel ~= nil and fillLevelInformations[v].capacity ~= nil then
											moVehicles[a].attachedValues[attachedNr].fillLevel = Utils.getNoNil(fillLevelInformations[v].fillLevel, 0);
											moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(fillLevelInformations[v].capacity, 0);
											moVehicles[a].attachedValues[attachedNr].fillLevelProzent = string.format("%1.0f", "".. tonumber(moVehicles[a].attachedValues[attachedNr].fillLevel)/tonumber(moVehicles[a].attachedValues[attachedNr].capacity)*100);
											moVehicles[a].attachedValues[attachedNr].warningCapacityColor = setProzentColor(moVehicles[a].attachedValues[attachedNr].fillLevelProzent, moVehicles[a].attachedValues[attachedNr].seedsSprayer, false);
										end;
										foundFill = true;
									end;
									if fillLevelInformations[v].isSprayer then	-- and not fillLevelInformations[v].isSeeds LS17 double FillType !! see first FillType !!						
										local sprayer = "";
										local fruitName = moVehicles[a].attachedValues[attachedNr].fruitName;
										moVehicles[a].attachedValues[attachedNr].seedsSprayer = true;
										if moFillTypes[fillLevelInformations[v].sprayerFruitType] ~= nil and moFillTypes[fillLevelInformations[v].sprayerFruitType].fruitName ~= nil then
											moVehicles[a].attachedValues[attachedNr].fruitName = moFillTypes[fillLevelInformations[v].sprayerFruitType].fruitName;
										end;								
										local desc = FillUtil.fillTypeIndexToDesc[fillLevelInformations[v].sprayerFruitConvertFillType];
										if desc == nil then desc = FillUtil.fillTypeIndexToDesc[fillLevelInformations[v].sprayerFruitType];end;
										if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
											sprayer = "(".. moFillTypes[desc.index].fruitName.. ")";
										end;
										if string.find(string.lower(sprayer), "!") then sprayer = "";end;										
										if string.find(fruitName, sprayer) then sprayer = "";end;
										moVehicles[a].attachedValues[attachedNr].fruitName = fruitName.. sprayer;
										if fillLevelInformations[v].fillLevel ~= nil and fillLevelInformations[v].capacity ~= nil then
											moVehicles[a].attachedValues[attachedNr].fillLevel = Utils.getNoNil(fillLevelInformations[v].fillLevel, 0);
											moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(fillLevelInformations[v].capacity, 0);
											moVehicles[a].attachedValues[attachedNr].fillLevelProzent = string.format("%1.0f", "".. tonumber(moVehicles[a].attachedValues[attachedNr].fillLevel)/tonumber(moVehicles[a].attachedValues[attachedNr].capacity)*100);
											moVehicles[a].attachedValues[attachedNr].warningCapacityColor = setProzentColor(moVehicles[a].attachedValues[attachedNr].fillLevelProzent, moVehicles[a].attachedValues[attachedNr].seedsSprayer, false);
										end;
										foundFill = true;
									end;
									if not fillLevelInformations[v].isSprayer and not fillLevelInformations[v].isSeeds then
										if fillLevelInformations[v].fillLevel ~= nil and fillLevelInformations[v].capacity ~= nil then
											moVehicles[a].attachedValues[attachedNr].fillLevel = Utils.getNoNil(fillLevelInformations[v].fillLevel, 0);
											moVehicles[a].attachedValues[attachedNr].capacity = Utils.getNoNil(fillLevelInformations[v].capacity, 0);
											moVehicles[a].attachedValues[attachedNr].fillLevelProzent = string.format("%1.0f", "".. tonumber(moVehicles[a].attachedValues[attachedNr].fillLevel)/tonumber(moVehicles[a].attachedValues[attachedNr].capacity)*100);
											moVehicles[a].attachedValues[attachedNr].warningCapacityColor = setProzentColor(moVehicles[a].attachedValues[attachedNr].fillLevelProzent, moVehicles[a].attachedValues[attachedNr].seedsSprayer, false);
											foundFill = true;
										end;
									end;
									if foundFill then break;end;
								end;
							end;
						end;
					end;					
					if string.find(moVehicles[a].attachedValues[attachedNr].vehicleType, "sprayer") or string.find(moVehicles[a].attachedValues[attachedNr].vehicleType, "manureBarrel") or string.find(moVehicles[a].attachedValues[attachedNr].vehicleType, "manureSpreader") and not string.find(moVehicles[a].attachedValues[attachedNr].vehicleType, "manureBarrelCultivator") then
						moVehicles[a].attachedValues[attachedNr].seedsSprayer = true;						
					end;
					--local foundFill = false;					
					--if not extraFillType then
					--	if attachedObj.currentFillType ~= nil then 
					--		fillType = attachedObj.currentFillType; 
					--	elseif attachedObj.currentInputFruitType ~= nil then 
					--		fillType = attachedObj.currentInputFruitType;
					--		moVehicles[a].attachedValues[attachedNr].seedsSprayer = true;					
					--	end;
					--end;
					if attachedObj.currentBalePlace ~= nil then
						fillType = attachedObj.currentBalePlace;
					end;
					if attachedObj.currentPallet ~= nil then
						fillType = attachedObj.currentPallet;
					end;					
					if fillType > 0 then
						local desc = FillUtil.fillTypeIndexToDesc[fillType];					
						if desc ~= nil and desc.index ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
							moVehicles[a].attachedValues[attachedNr].fruitName = moFillTypes[desc.index].fruitName;
						end;					
					end;									
					if attachedObj.attachedImplements ~= nil and attachedNr <= maxAttachedNr then
						setNextAttached(a, attachedObj);						
					end;
					if moVehicles[a].attachedValues[attachedNr].warningCapacityColor == nil or moVehicles[a].attachedValues[attachedNr].capacity == 0 then
						moVehicles[a].attachedValues[attachedNr].fillLevelProzent = nil;
						moVehicles[a].attachedValues[attachedNr].warningCapacityColor = moSetGetGui.pdaVI.defaultColor;
						moVehicles[a].attachedValues[attachedNr].fruitName = "";
					end;
				end;				
				if vehicle.attachedImplements then					
					moVehicles[a].attachedValues = {};
					for index,attached in pairs(vehicle.attachedImplements) do
						if attached ~= nil and attached.object ~= nil then							
							setAttached(a, attached.object)
						end;						
					end;
				end;
				if moVehicles[a].isSteerable and moSetGetGui.pdaVI.fieldDisplay then moVehicles[a].field = getField(vehicle);end;
				--if string.find(moVehicles[a].vehicleType, "combine_animated") or string.find(moVehicles[a].vehicleType, "selfPropelledPotatoHarvester") and a ~= 1 then
				--	local noticeVehicle = moVehicles[a];
				--	table.remove(moVehicles[a]);
				--	table.insert(moVehicles, 1, noticeVehicle)
				--end;				
			else
				table.remove(moVehicles[a])
				if moGeneralSettings.vehicleControlled[2][vehicle.rootNode] ~= nil then table.remove(moGeneralSettings.vehicleControlled[2][vehicle.rootNode]);end;
			end;			
		end;		
	end;	
end;

function setVehicleName(self, tableVehicle, vehicle, attachable)
	
	local vehicleName = "Unknown";
	local category = "Unknown";
	local storeItem = StoreItemsUtil.storeItemsByXMLFilename[vehicle.configFileName:lower()];
    if storeItem ~= nil then
        if storeItem.name ~= nil then
            vehicleName = tostring(storeItem.name);
        end;
        --if storeItem.category ~= nil and storeItem.category ~= "" then
        --    category = tostring(storeItem.category);
        --end;
	end;
	--print("vehiclename...".. tostring(name).. " -category...".. tostring(category))
	
	
	--local vehicleXml = loadXMLFile("MultiOverlayV2_XML", vehicle.configFileName, "vehicle");
	if string.find(tostring(vehicle.configFileName), "locomotive") then
		vehicleName = "Train";		
		if not attachable then tableVehicle.typeDesc = vehicleName;end;
	elseif string.find(tostring(vehicle.configFileName), "stationCrane") then
		vehicleName = "Crane";
		if not attachable then tableVehicle.typeDesc = vehicleName;end;
	elseif string.find(tostring(vehicle.configFileName), "wagon") then
		vehicleName = "Wagon";
		if attachable then tableVehicle.typeDesc = vehicleName;end;	
	elseif vehicle.time ~= nil and vehicle.time > 0 then
		vehicleName = vehicleName.. "-Missions Vehicle";
	end;
	--tableVehicle.name = vehicleName;	
	return vehicleName;
end;

function setProzentColor(fillProzent, reverse, fuel)	
	local ratio = tonumber(fillProzent);	
	local capacityError = tostring(fillProzent);
	if ratio == nil or not tonumber(ratio) or not tonumber(fillProzent) or capacityError == "nan" or capacityError == "inf" then return nil;end; --ForageHarvester LS17 Error Fix
	if fuel then
		if tonumber(ratio) < 10 then return true;end;
		return false;
	end;
	if tonumber(ratio) >= 90 then
		if reverse then return moSetGetGui.pdaVI.warningColor0;end;
		return moSetGetGui.pdaVI.warningColor4;
	elseif tonumber(ratio) < 90 and tonumber(ratio) >= 75 then
		if reverse then return moSetGetGui.pdaVI.warningColor1;end;
		return moSetGetGui.pdaVI.warningColor3;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		return moSetGetGui.pdaVI.warningColor2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 15 then
		if reverse then return moSetGetGui.pdaVI.warningColor3;end;
		return moSetGetGui.pdaVI.warningColor1;
	elseif tonumber(ratio) < 15 then
		if reverse then return moSetGetGui.pdaVI.warningColor4;end;
		return moSetGetGui.pdaVI.warningColor0;
	end;
	return nil; --ForageHarvester LS17 Error Fix
end;

function setRentCarColor(rentCarTime)	
	local ratio = tonumber(rentCarTime);	
	if tonumber(ratio) >= 3600000 then
		--print(" > time.....".. tostring(ratio))
		return moSetGetGui.pdaVI.warningColor0, false, 0;
	elseif tonumber(ratio) < 3600000 and tonumber(ratio) >= 2400000 then		
		--print(" < time.....".. tostring(ratio))
		return moSetGetGui.pdaVI.warningColor1, false, 1;
	elseif tonumber(ratio) < 2400000 and tonumber(ratio) >= 1200000 then
		return moSetGetGui.pdaVI.warningColor2, false, 2;
	elseif tonumber(ratio) < 1200000 and tonumber(ratio) >= 600000 then
		return moSetGetGui.pdaVI.warningColor3, true, 3;
	elseif tonumber(ratio) < 600000 then		
		return moSetGetGui.pdaVI.warningColor4, true, 4;
	end;	
end;

function getFillLevelInformation(vehicle, fillLevelInformations, isAttached, nr)
    --if #fillLevelInformations > 5 then return;end;
	local attachedNextNr = nr;
	if vehicle.fillUnits ~= nil then
        for _,fillUnit in pairs(vehicle.fillUnits) do
            --if fillUnit.capacity ~= nil then --and fillUnit.showOnHud then
                local added = false;               
				local isSeeds = false;
				local isSprayer = false;
				local seedsFruitType = 0;
				local seedsFruitConvertFillType = 0;
				local sprayerFillType = 0;
				local sprayerFruitConvertFillType = 0;
				if vehicle.seeds ~= nil and vehicle.currentSeed ~= nil then
					isSeeds = true;
					seedsFruitType = Utils.getNoNil(vehicle.seeds[vehicle.currentSeed], 0);
					seedsFruitConvertFillType = Utils.getNoNil(FruitUtil.fruitTypeToFillType[seedsFruitType], 0);
				end;
				if vehicle.sprayer ~= nil then
					isSprayer = true;
					for fType,state in pairs(fillUnit.fillTypes) do
						if state then
							sprayerFillType = fType;
							sprayerFruitConvertFillType = Utils.getNoNil(FruitUtil.fruitTypeToFillType[sprayerFillType], 0);
							break;
						end;
					end;
				end;
				--for i,fillLevelInformation in pairs(fillLevelInformations) do
                --    if fillLevelInformation.fillType == fillUnit.currentFillType then
                --        fillLevelInformation.fillType = fillUnit.currentFillType;
				--		fillLevelInformation.fillLevel = fillUnit.fillLevel;
                --        fillLevelInformation.capacity = fillUnit.capacity;
                --        added = true;
                --        break;
                --    end
                --end
                if not added then
                    --fillLevelInformations[#fillLevelInformations+1] = {fillType=fillUnit.currentFillType, fillLevel=fillUnit.fillLevel, capacity=fillUnit.capacity};
					table.insert(fillLevelInformations, {
					fillType=fillUnit.currentFillType, 
					fillLevel=fillUnit.fillLevel, 
					capacity=Utils.getNoNil(fillUnit.capacity, 0),
					isSeeds=isSeeds, 
					seedsFruitType=seedsFruitType, 
					seedsFruitConvertFillType=seedsFruitConvertFillType, 
					isSprayer=isSprayer, 
					sprayerFillType=sprayerFillType,
					sprayerFruitConvertFillType=sprayerFruitConvertFillType,
					isAttached=isAttached,
					attachedNr = attachedNextNr;
					});					
                end;
            --end;
        end;
    end;
	attachedNextNr = attachedNextNr+1;
    for _, implement in pairs(vehicle.attachedImplements) do
       if implement.object ~= nil then
            getFillLevelInformation(implement.object, fillLevelInformations, true, attachedNextNr);			
       end;
    end;
end;